"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var ControlMode_1 = require("../datatypes/ControlMode");
var sp_1 = require("@pnp/sp");
var typescript_string_operations_1 = require("typescript-string-operations");
var ListFormService = /** @class */ (function () {
    function ListFormService() {
    }
    /**
     * Gets the schema for all relevant fields for a specified SharePoint list form.
     *
     * @param webUrl The absolute Url to the SharePoint site.
     * @param listUrl The server-relative Url to the SharePoint list.
     * @param viewId The type of form (Display, New, Edit)
     * @returns Promise object represents the array of field schema for all relevant fields for this list form.
     */
    ListFormService.prototype.getViewFields = function (webUrl, listName, viewId) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
                        var web, list, ViewXml;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    web = new sp_1.Web(webUrl);
                                    list = web
                                        .lists
                                        .getByTitle(listName);
                                    return [4 /*yield*/, list
                                            .getView(viewId)
                                            .get()];
                                case 1:
                                    ViewXml = (_a.sent()).HtmlSchemaXml;
                                    return [4 /*yield*/, list
                                            .renderListDataAsStream({ ViewXml: ViewXml, RenderOptions: sp_1.RenderListDataOptions.ListSchema })
                                            .then(function (data) {
                                            resolve(data.Field);
                                        })
                                            .catch(function (error) {
                                            reject(error);
                                        })];
                                case 2:
                                    _a.sent();
                                    return [2 /*return*/];
                            }
                        });
                    }); })];
            });
        });
    };
    /**
     * Gets the schema for all relevant fields for a specified SharePoint list form.
     *
     * @param webUrl The absolute Url to the SharePoint site.
     * @param listUrl The server-relative Url to the SharePoint list.
     * @param viewId The type of form (Display, New, Edit)
     * @returns Promise object represents the array of field schema for all relevant fields for this list form.
     */
    ListFormService.prototype.getViewItems = function (webUrl, listName, viewId, overrideParameters, paging) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
                        var web, list, ViewXml;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    web = new sp_1.Web(webUrl);
                                    list = web.lists.getByTitle(listName);
                                    return [4 /*yield*/, list.getView(viewId).get()];
                                case 1:
                                    ViewXml = (_a.sent()).HtmlSchemaXml;
                                    return [4 /*yield*/, list
                                            .renderListDataAsStream({
                                            ViewXml: ViewXml,
                                            AllowMultipleValueFilterForTaxonomyFields: true,
                                            RenderOptions: sp_1.RenderListDataOptions.ListData,
                                            Paging: paging
                                        }, overrideParameters)
                                            .then(function (data) {
                                            resolve(data);
                                        })
                                            .catch(function (error) {
                                            reject(error);
                                        })];
                                case 2:
                                    _a.sent();
                                    return [2 /*return*/];
                            }
                        });
                    }); })];
            });
        });
    };
    /**
     * Gets the schema for all relevant fields for a specified SharePoint list form.
     *
     * @param webUrl The absolute Url to the SharePoint site.
     * @param listName The name of the list.
     * @param formType The type of form (Display, New, Edit)
     * @returns Promise object represents the array of field schema for all relevant fields for this list form.
     */
    ListFormService.prototype.getFieldSchemasForForm = function (webUrl, listName, formType) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            var web = new sp_1.Web(webUrl);
            web
                .lists
                .getByTitle(listName)
                // tslint:disable-next-line:max-line-length
                .renderListDataAsStream({ RenderOptions: sp_1.RenderListDataOptions.ClientFormSchema, ViewXml: '<View><ViewFields><FieldRef Name="ID"/></ViewFields></View>' })
                .then(function (data) {
                var form = (formType === ControlMode_1.ControlMode.New)
                    ? data.ClientForms.New
                    : data.ClientForms.Edit;
                resolve(form[Object.keys(form)[0]]);
            })
                .catch(function (error) {
                reject(_this.getErrorMessage(webUrl, error));
            });
        });
    };
    /**
     * Returns an error message based on the specified error object
     * @param error : An error string/object
     */
    ListFormService.prototype.getErrorMessage = function (webUrl, error) {
        var errorMessage = error.statusText
            ? error.statusText
            : error.statusMessage
                ? error.statusMessage
                : error;
        var serverUrl = "{window.location.protocol}//{window.location.hostname}";
        var webServerRelativeUrl = webUrl.replace(serverUrl, '');
        if (error.status === 403) {
            errorMessage = typescript_string_operations_1.String.Format(
            // tslint:disable-next-line:max-line-length
            'You do not have access to the previously configured web url \'{0}\'. Either leav' +
                'e the WebPart properties as is or select another web url.', webServerRelativeUrl);
        }
        else if (error.status === 404) {
            errorMessage = typescript_string_operations_1.String.Format(
            // tslint:disable-next-line:max-line-length
            'The previously configured web url \'{0}\' is not found anymore. Either leave the' +
                ' WebPart properties as is or select another web url.', webServerRelativeUrl);
        }
        return errorMessage;
    };
    return ListFormService;
}());
exports.ListFormService = ListFormService;
