"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var sp_taxonomy_1 = require("@pnp/sp-taxonomy");
var typescript_string_operations_1 = require("typescript-string-operations");
/**
 * Service implementation to manage term stores in SharePoint
 */
var SPTermStorePickerService = /** @class */ (function () {
    function SPTermStorePickerService() {
    }
    /**
     * Gets the collection of term stores for the provided Web Url.
     *
     * @param webUrl The absolute Url to the SharePoint site.
     * @returns Promise object represents the term store object.
     */
    SPTermStorePickerService.prototype.getTermStores = function (webUrl) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
                        var taxonomy;
                        var _this = this;
                        return __generator(this, function (_a) {
                            taxonomy = new sp_taxonomy_1.Session(webUrl);
                            taxonomy.termStores
                                .get()
                                .then(function (res) {
                                resolve(res);
                            })
                                .catch(function (error) {
                                reject(_this.getErrorMessage(webUrl, error));
                            });
                            return [2 /*return*/];
                        });
                    }); })];
            });
        });
    };
    /**
     * Gets the current term set
     *
     * @param webUrl The absolute Url to the SharePoint site.
     * @param termSetID The Term Set ID
     * @returns Promise object represents the the term set data.
     */
    SPTermStorePickerService.prototype.getTermSet = function (webUrl, termSetID) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
                        var termStores, termStore;
                        var _this = this;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, this.getTermStores(webUrl)];
                                case 1:
                                    termStores = _a.sent();
                                    termStore = termStores[0];
                                    termStore
                                        .getTermSetById(termSetID)
                                        .get()
                                        .then(function (res) {
                                        resolve(res);
                                    })
                                        .catch(function (error) {
                                        reject(_this.getErrorMessage(webUrl, error));
                                    });
                                    return [2 /*return*/];
                            }
                        });
                    }); })];
            });
        });
    };
    /**
     * Retrieve all terms for the given term set
     * @param webUrl The absolute Url to the SharePoint site.
     * @param termSetID The Term Set ID
     * @returns Promise object represents the the term set data.
     */
    SPTermStorePickerService.prototype.getAllTerms = function (webUrl, termSetNameOrID) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
                        var termSet;
                        var _this = this;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, this.getTermSet(webUrl, termSetNameOrID)];
                                case 1:
                                    termSet = _a.sent();
                                    termSet.terms
                                        .get()
                                        .then(function (res) {
                                        resolve(res);
                                    })
                                        .catch(function (error) {
                                        reject(_this.getErrorMessage(webUrl, error));
                                    });
                                    return [2 /*return*/];
                            }
                        });
                    }); })];
            });
        });
    };
    /**
     * Retrieve all terms that starts with the searchText
     * @param webUrl The absolute Url to the SharePoint site.
     * @param searchText The search term that text is returned by.
     * @returns Retrieve all terms for the given searchText
     */
    SPTermStorePickerService.prototype.searchTermsByName = function (webUrl, searchText) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
                        var termStores, termStore, labelMatchInfo;
                        var _this = this;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, this.getTermStores(webUrl)];
                                case 1:
                                    termStores = _a.sent();
                                    termStore = termStores[0];
                                    labelMatchInfo = {
                                        StringMatchOption: sp_taxonomy_1.StringMatchOption.StartsWith,
                                        TermLabel: searchText
                                    };
                                    termStore
                                        .getTerms(labelMatchInfo)
                                        .get()
                                        .then(function (res) {
                                        resolve(res);
                                    })
                                        .catch(function (error) {
                                        reject(_this.getErrorMessage(webUrl, error));
                                    });
                                    return [2 /*return*/];
                            }
                        });
                    }); })];
            });
        });
    };
    /**
     * Searches terms for the given term set
     * @param webUrl The absolute Url to the SharePoint site.
     * @param termSetID The Term Set ID
     * @param searchText The search term that text is returned by.
     * @returns Retrieve all terms for the given searchText in the Term Set ID.
     */
    SPTermStorePickerService.prototype.searchTermsByTermSet = function (webUrl, termSetID, searchText) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                return [2 /*return*/, new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
                        var terms, returnTerms;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, this.getAllTerms(webUrl, termSetID)];
                                case 1:
                                    terms = _a.sent();
                                    returnTerms = [];
                                    terms.forEach(function (term) {
                                        if (term.Name.toLowerCase().indexOf(searchText.toLowerCase()) !== -1) {
                                            returnTerms.push(term);
                                        }
                                    });
                                    resolve(returnTerms);
                                    return [2 /*return*/];
                            }
                        });
                    }); })];
            });
        });
    };
    SPTermStorePickerService.prototype.getErrorMessage = function (webUrl, error) {
        var errorMessage = error.statusText
            ? error.statusText
            : error.statusMessage ? error.statusMessage : error;
        var serverUrl = "{window.location.protocol}//{window.location.hostname}";
        var webServerRelativeUrl = webUrl.replace(serverUrl, '');
        if (error.status === 403) {
            errorMessage = typescript_string_operations_1.String.Format(
            // tslint:disable-next-line:max-line-length
            'You do not have access to the previously configured web url \'{0}\'. Either leav' +
                'e the WebPart properties as is or select another web url.', webServerRelativeUrl);
        }
        else if (error.status === 404) {
            errorMessage = typescript_string_operations_1.String.Format(
            // tslint:disable-next-line:max-line-length
            'The previously configured web url \'{0}\' is not found anymore. Either leave the' +
                ' WebPart properties as is or select another web url.', webServerRelativeUrl);
        }
        return errorMessage;
    };
    return SPTermStorePickerService;
}());
exports.default = SPTermStorePickerService;
