import * as React from 'react';
import { IListFormProps } from './types/IListFormProps';
import { IListFormState } from './types/IListFormState';
import './ListForm.module.scss';
/*************************************************************************************
 * React Component to render a SharePoint list form on any page.
 * The list form can be configured to be either a new form for adding a new list item,
 * an edit form for changing an existing list item or a display form for showing the
 * fields of an existing list item.
 * In design mode the fields to render can be moved, added and deleted.
 *************************************************************************************/
export declare class ListForm extends React.Component<IListFormProps, IListFormState> {
    private listFormService;
    constructor(props: IListFormProps);
    render(): JSX.Element;
    componentDidMount(): void;
    componentWillReceiveProps(nextProps: IListFormProps): void;
    private renderNotifications;
    private renderErrors;
    private renderFields;
    private readSchema;
    private valueChanged;
    private clearError;
    private getFields;
}
