"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var Utilities_1 = require("office-ui-fabric-react/lib/Utilities");
var ListFormService_1 = require("../common/services/ListFormService");
var Spinner_1 = require("office-ui-fabric-react/lib/Spinner");
var MessageBar_1 = require("office-ui-fabric-react/lib/MessageBar");
var Utilities_2 = require("office-ui-fabric-react/lib/Utilities");
var SPFormField_1 = require("./SPFormField");
require("./ListForm.module.scss");
var styles = {
    listForm: 'listForm_7906cbc9',
    title: 'title_7906cbc9',
    description: 'description_7906cbc9',
    formFieldsContainer: 'formFieldsContainer_7906cbc9',
    isDataLoading: 'isDataLoading_7906cbc9',
    formButtonsContainer: 'formButtonsContainer_7906cbc9',
    addFieldToolbox: 'addFieldToolbox_7906cbc9',
    addFieldToolboxPlusButton: 'addFieldToolboxPlusButton_7906cbc9'
};
/*************************************************************************************
 * React Component to render a SharePoint list form on any page.
 * The list form can be configured to be either a new form for adding a new list item,
 * an edit form for changing an existing list item or a display form for showing the
 * fields of an existing list item.
 * In design mode the fields to render can be moved, added and deleted.
 *************************************************************************************/
var ListForm = /** @class */ (function (_super) {
    __extends(ListForm, _super);
    function ListForm(props) {
        var _this = _super.call(this, props) || this;
        // set initial state
        _this.state = {
            isLoadingSchema: false,
            isLoadingData: false,
            isSaving: false,
            data: {},
            originalData: {},
            errors: [],
            notifications: [],
            fieldErrors: {}
        };
        _this.listFormService = new ListFormService_1.ListFormService();
        return _this;
    }
    ListForm.prototype.render = function () {
        return (React.createElement("div", { className: styles.listForm },
            React.createElement("div", { className: Utilities_2.css(styles.title, 'ms-font-xl') }, this.props.title),
            this.props.description && React.createElement("div", { className: styles.description }, this.props.description),
            this.renderNotifications(),
            this.renderErrors(),
            !this.props.listName ? (React.createElement(MessageBar_1.MessageBar, { messageBarType: MessageBar_1.MessageBarType.warning }, "Please configure a list for this component first.")) : (''),
            this.state.isLoadingSchema ? (React.createElement(Spinner_1.Spinner, { size: Spinner_1.SpinnerSize.large, label: 'Loading the form...' })) : (this.state.fieldsSchema && (React.createElement("div", null,
                React.createElement("div", { className: Utilities_2.css(styles.formFieldsContainer, this.state.isLoadingData ? styles.isDataLoading : null) }, this.renderFields()))))));
    };
    ListForm.prototype.componentDidMount = function () {
        this.readSchema(this.props.listName, this.props.formType);
    };
    ListForm.prototype.componentWillReceiveProps = function (nextProps) {
        if (this.props.listName !== nextProps.listName || this.props.formType !== nextProps.formType) {
            this.readSchema(nextProps.listName, nextProps.formType);
        }
    };
    ListForm.prototype.renderNotifications = function () {
        var _this = this;
        if (this.state.notifications.length === 0) {
            return null;
        }
        setTimeout(function () {
            _this.setState(__assign({}, _this.state, { notifications: [] }));
        }, 4000);
        return (React.createElement("div", null, this.state.notifications.map(function (item, _idx) { return (React.createElement(MessageBar_1.MessageBar, { messageBarType: MessageBar_1.MessageBarType.success }, item)); })));
    };
    ListForm.prototype.renderErrors = function () {
        var _this = this;
        return this.state.errors.length > 0 ? (React.createElement("div", null, this.state.errors.map(function (item, idx) { return (React.createElement(MessageBar_1.MessageBar, { messageBarType: MessageBar_1.MessageBarType.error, isMultiline: true, onDismiss: function (_ev) { return _this.clearError(idx); } }, item)); }))) : null;
    };
    ListForm.prototype.renderFields = function () {
        var _this = this;
        var _a = this.state, fieldsSchema = _a.fieldsSchema, data = _a.data, fieldErrors = _a.fieldErrors;
        var fields = this.getFields();
        return fields && fields.length > 0 ? (React.createElement("div", { className: "ard-formFieldsContainer" }, fields.map(function (field, _idx) {
            var fieldSchemas = fieldsSchema.filter(function (f) { return f.InternalName === field.fieldName; });
            if (fieldSchemas.length > 0) {
                var fieldSchema = fieldSchemas[0];
                var value = data[field.fieldName];
                var extraData = void 0;
                if (data.hasOwnProperty(field.fieldName + '.')) {
                    extraData = data[field.fieldName + '.'];
                }
                else {
                    extraData = Object.keys(data)
                        .filter(function (propName) { return propName.indexOf(field.fieldName + '.') === 0; })
                        .reduce(function (newData, pn) {
                        newData[pn.substring(field.fieldName.length + 1)] = data[pn];
                        return newData;
                    }, {});
                }
                var errorMessage = fieldErrors[field.fieldName];
                var fieldComponent = SPFormField_1.default({
                    fieldSchema: fieldSchema,
                    controlMode: _this.props.formType,
                    value: value,
                    extraData: extraData,
                    errorMessage: errorMessage,
                    hideIfFieldUnsupported: !_this.props.showUnsupportedFields,
                    valueChanged: function (val) { return _this.valueChanged(field.fieldName, val); },
                    webUrl: _this.props.webUrl
                });
                return fieldComponent;
            }
            return null;
        }))) : (React.createElement(MessageBar_1.MessageBar, { messageBarType: MessageBar_1.MessageBarType.warning }, "No fields available!"));
    };
    ListForm.prototype.readSchema = function (listName, formType) {
        return __awaiter(this, void 0, void 0, function () {
            var fieldsSchema, error_1, errorText;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        if (!listName) {
                            this.setState(__assign({}, this.state, { isLoadingSchema: false, errors: ['Please configure a list in the web part\'s editor first.'] }));
                            return [2 /*return*/];
                        }
                        this.setState(__assign({}, this.state, { isLoadingSchema: true }));
                        return [4 /*yield*/, this.listFormService.getFieldSchemasForForm(this.props.webUrl, listName, formType)];
                    case 1:
                        fieldsSchema = _a.sent();
                        this.setState(__assign({}, this.state, { isLoadingSchema: false, fieldsSchema: fieldsSchema }));
                        return [3 /*break*/, 3];
                    case 2:
                        error_1 = _a.sent();
                        errorText = "Error loading for list with name: " + listName + ": " + error_1;
                        this.setState(__assign({}, this.state, { isLoadingSchema: false, errors: this.state.errors.concat([errorText]) }));
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    ListForm.prototype.valueChanged = function (fieldName, newValue) {
        var _this = this;
        this.setState(function (prevState, _props) {
            var _a, _b;
            return __assign({}, prevState, { data: __assign({}, prevState.data, (_a = {}, _a[fieldName] = newValue, _a)), fieldErrors: __assign({}, prevState.fieldErrors, (_b = {}, _b[fieldName] = prevState.fieldsSchema.filter(function (item) { return item.InternalName === fieldName; })[0].Required &&
                    !newValue
                    ? 'Please enter a value!'
                    : '', _b)) });
        }, function () {
            _this.props.onUpdateFields(_this.state.fieldsSchema, _this.state.data);
        });
    };
    ListForm.prototype.clearError = function (idx) {
        this.setState(function (prevState, _props) {
            return __assign({}, prevState, { errors: prevState.errors.splice(idx, 1) });
        });
    };
    ListForm.prototype.getFields = function () {
        var fields = this.props.fields;
        if (!fields && this.state.fieldsSchema) {
            fields = this.state.fieldsSchema.map(function (field) { return ({
                key: field.InternalName,
                fieldName: field.InternalName
            }); });
        }
        return fields;
    };
    __decorate([
        Utilities_1.autobind
    ], ListForm.prototype, "readSchema", null);
    __decorate([
        Utilities_1.autobind
    ], ListForm.prototype, "valueChanged", null);
    return ListForm;
}(React.Component));
exports.ListForm = ListForm;
