import * as React from 'react';
import { IListViewProps } from './types/IListViewProps';
import { IListViewState } from './types/IListViewState';
import { Selection } from 'office-ui-fabric-react/lib/DetailsList';
/*************************************************************************************
 * React Component to render a SharePoint list on any page.
 *************************************************************************************/
export declare class ListView extends React.Component<IListViewProps, IListViewState> {
    readonly _selection: Selection;
    private listFormService;
    private _isMounted;
    constructor(props: IListViewProps);
    /**
     * Default React component render method
     */
    render(): JSX.Element;
    /**
     * Lifecycle hook when component is mounted
     */
    componentDidMount(): void;
    componentWillUnmount(): void;
    /**
     * Lifecycle hook when component did update after state or property changes
     * @param nextProps
     */
    componentWillReceiveProps(nextProps: IListViewProps): void;
    private renderList;
    private renderErrors;
    private readSchema;
    private readListData;
    private _onLoadNextPage;
    /**
     * Check if sorting needs to be set to the column
     * @param ev
     * @param column
     */
    private _onColumnClick;
    private clearError;
    private _onRenderRow;
}
