"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var Utilities_1 = require("office-ui-fabric-react/lib/Utilities");
var DetailsList_1 = require("office-ui-fabric-react/lib/DetailsList");
var ListFormService_1 = require("../common/services/ListFormService");
var MessageBar_1 = require("office-ui-fabric-react/lib/MessageBar");
var Spinner_1 = require("office-ui-fabric-react/lib/Spinner");
var SPViewFields_1 = require("./SPViewFields");
/*************************************************************************************
 * React Component to render a SharePoint list on any page.
 *************************************************************************************/
var ListView = /** @class */ (function (_super) {
    __extends(ListView, _super);
    function ListView(props) {
        var _this = _super.call(this, props) || this;
        _this._onLoadNextPage = function (index) {
            var _a = _this.state, items = _a.items, NextHref = _a.NextHref;
            _this.setState(__assign({}, _this.state, { isLoadingData: true }));
            _this.listFormService
                .getViewItems(_this.props.webUrl, _this.props.listName, _this.props.viewId, null, NextHref.substring(1))
                .then(function (res) {
                var tempRows = res.Row;
                if (res.NextHref) {
                    tempRows.push(null);
                }
                items = items.slice(0, items.length - 1).concat(tempRows);
                if (_this._isMounted) {
                    _this.setState(__assign({}, _this.state, { isLoadingData: false, items: items, NextHref: res.NextHref }));
                }
            })
                .catch(function (error) {
                var errorText = "Error loading for data list with name: " + _this.props.listName + ": " + error;
                _this.setState(__assign({}, _this.state, { isLoadingData: false, errors: _this.state.errors.concat([errorText]) }));
            });
            return null;
        };
        /**
         * Check if sorting needs to be set to the column
         * @param ev
         * @param column
         */
        _this._onColumnClick = function (ev, column) {
            var columns = _this.state.columns;
            var newColumns = columns.slice();
            var currColumn = newColumns.filter(function (currCol, idx) {
                return column.key === currCol.key;
            })[0];
            newColumns.forEach(function (newCol) {
                if (newCol === currColumn) {
                    currColumn.isSortedDescending = !currColumn.isSortedDescending;
                    currColumn.isSorted = true;
                }
                else {
                    newCol.isSorted = false;
                    newCol.isSortedDescending = true;
                }
            });
            var overrideParameters = {
                SortField: currColumn.fieldName,
                SortDir: currColumn.isSortedDescending ? 'Desc' : 'Asc'
            };
            _this.readListData(overrideParameters);
            _this.setState({ columns: newColumns });
        };
        _this._onRenderRow = function (props) {
            return React.createElement(DetailsList_1.DetailsRow, __assign({}, props, { "aria-busy": false }));
        };
        // Binding the functions
        _this._selection = new DetailsList_1.Selection({
            onSelectionChanged: function () {
                _this.props.selection(_this._selection.getSelection());
            }
        });
        // set initial state
        _this.state = {
            isLoadingFields: false,
            isLoadingData: false,
            errors: [],
            items: []
        };
        _this.listFormService = new ListFormService_1.ListFormService();
        return _this;
    }
    /**
     * Default React component render method
     */
    ListView.prototype.render = function () {
        return (React.createElement("div", null,
            this.renderErrors(),
            !this.props.listName ? (React.createElement(MessageBar_1.MessageBar, { messageBarType: MessageBar_1.MessageBarType.warning }, "Please configure a list for this component first.")) : (''),
            this.state.isLoadingFields ? (React.createElement(Spinner_1.Spinner, { size: Spinner_1.SpinnerSize.large, label: 'Loading the view...' })) : (React.createElement("div", null, this.renderList()))));
    };
    /**
     * Lifecycle hook when component is mounted
     */
    ListView.prototype.componentDidMount = function () {
        this._isMounted = true;
        if (this.props.listName != null && this.props.viewId != null) {
            this.readSchema(this.props.listName, this.props.viewId);
        }
    };
    ListView.prototype.componentWillUnmount = function () {
        this._isMounted = false;
    };
    /**
     * Lifecycle hook when component did update after state or property changes
     * @param nextProps
     */
    ListView.prototype.componentWillReceiveProps = function (nextProps) {
        if (this.props.listName !== nextProps.listName || this.props.viewId !== nextProps.viewId) {
            this.readSchema(nextProps.listName, nextProps.viewId);
        }
        if (this.props.searchTerms !== nextProps.searchTerms) {
            var overrideParameters = {
                InplaceSearchQuery: nextProps.searchTerms
            };
            this.readListData(overrideParameters);
        }
    };
    ListView.prototype.renderList = function () {
        var _a = this.state, viewSchema = _a.viewSchema, columns = _a.columns, items = _a.items;
        // const _columns: IColumn[] = [];
        return (React.createElement("div", null, viewSchema && viewSchema.length > 0 ? (React.createElement("div", null,
            React.createElement(DetailsList_1.DetailsList, { items: items, compact: this.props.compact, columns: columns, setKey: "ListViewControl", layoutMode: DetailsList_1.DetailsListLayoutMode.justified, isHeaderVisible: true, selectionPreservedOnEmptyClick: true, enterModalSelectionOnTouch: true, onRenderRow: this._onRenderRow, selectionMode: this.props.selectionMode || DetailsList_1.SelectionMode.none, selection: this._selection, onRenderMissingItem: this._onLoadNextPage }),
            ' ',
            this.state.isLoadingData && (React.createElement(Spinner_1.Spinner, { className: "loadingSpinner", label: "Loading...", hidden: !this.state.isLoadingData })))) : (React.createElement(MessageBar_1.MessageBar, { messageBarType: MessageBar_1.MessageBarType.warning }, "No fields available!"))));
    };
    ListView.prototype.renderErrors = function () {
        var _this = this;
        return this.state.errors.length > 0 ? (React.createElement("div", null, this.state.errors.map(function (item, idx) { return (React.createElement(MessageBar_1.MessageBar, { messageBarType: MessageBar_1.MessageBarType.error, isMultiline: true, onDismiss: function (_ev) { return _this.clearError(idx); } }, item)); }))) : null;
    };
    ListView.prototype.readSchema = function (listName, viewId) {
        return __awaiter(this, void 0, void 0, function () {
            var viewSchema, columns_1, error_1, errorText;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        if (!listName) {
                            if (this._isMounted) {
                                this.setState(__assign({}, this.state, { isLoadingFields: false, errors: ['Please configure pass a list as a parameter.'] }));
                            }
                            return [2 /*return*/];
                        }
                        this.setState(__assign({}, this.state, { isLoadingFields: true }));
                        return [4 /*yield*/, this.listFormService.getViewFields(this.props.webUrl, listName, viewId)];
                    case 1:
                        viewSchema = _a.sent();
                        columns_1 = [];
                        viewSchema.forEach(function (element) {
                            columns_1.push(SPViewFields_1.SPViewFields.GenerateColumn(element, _this._onColumnClick));
                        });
                        if (this._isMounted) {
                            this.setState(__assign({}, this.state, { isLoadingFields: false, viewSchema: viewSchema,
                                columns: columns_1 }));
                            this.readListData();
                        }
                        return [3 /*break*/, 3];
                    case 2:
                        error_1 = _a.sent();
                        errorText = "Error loading for list with name: " + listName + ": " + error_1;
                        if (this._isMounted) {
                            this.setState(__assign({}, this.state, { isLoadingFields: false, errors: this.state.errors.concat([errorText]) }));
                        }
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    ListView.prototype.readListData = function (overrideParameters) {
        return __awaiter(this, void 0, void 0, function () {
            var items, rows, error_2, errorText;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        if (this._isMounted) {
                            this.setState(__assign({}, this.state, { isLoadingData: true }));
                        }
                        return [4 /*yield*/, this.listFormService.getViewItems(this.props.webUrl, this.props.listName, this.props.viewId, overrideParameters)];
                    case 1:
                        items = _a.sent();
                        rows = items.Row;
                        if (items.NextHref) {
                            rows.push(null);
                        }
                        if (this._isMounted) {
                            this.setState(__assign({}, this.state, { isLoadingData: false, items: rows, NextHref: items.NextHref }));
                        }
                        return [3 /*break*/, 3];
                    case 2:
                        error_2 = _a.sent();
                        errorText = "Error loading for data list with name: " + this.props.listName + ": " + error_2;
                        if (this._isMounted) {
                            this.setState(__assign({}, this.state, { isLoadingData: false, errors: this.state.errors.concat([errorText]) }));
                        }
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    ListView.prototype.clearError = function (idx) {
        this.setState(function (prevState, _props) {
            return __assign({}, prevState, { errors: prevState.errors.splice(idx, 1) });
        });
    };
    __decorate([
        Utilities_1.autobind
    ], ListView.prototype, "readSchema", null);
    __decorate([
        Utilities_1.autobind
    ], ListView.prototype, "readListData", null);
    return ListView;
}(React.Component));
exports.ListView = ListView;
