"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var DatePicker_1 = require("office-ui-fabric-react/lib/DatePicker");
var DateFormField = /** @class */ (function (_super) {
    __extends(DateFormField, _super);
    function DateFormField(props) {
        return _super.call(this, props) || this;
    }
    DateFormField.prototype.render = function () {
        var _this = this;
        return (React.createElement(DatePicker_1.DatePicker, __assign({}, this.props, { parseDateFromString: function (dateStr) { return new Date(Date.parse(dateStr)); }, formatDate: function (date) {
                return typeof date.toLocaleDateString === 'function' ? date.toLocaleDateString(_this.props.locale) : '';
            }, strings: this.strings() })));
    };
    DateFormField.prototype.strings = function () {
        return {
            UnsupportedFieldType: 'Unsupported field type',
            InvalidNumberValue: 'The value should be a number, actual is',
            ToggleOnAriaLabel: 'This toggle is checked. Press to uncheck.',
            ToggleOffAriaLabel: 'This toggle is unchecked. Press to check.',
            ToggleOnText: 'Yes',
            ToggleOffText: 'No',
            TextFormFieldPlaceholder: 'Enter text here',
            DateFormFieldPlaceholder: 'Enter a date',
            NumberFormFieldPlaceholder: 'Enter value here',
            LookupEmptyOptionText: '(None)',
            // IDatePickerStrings
            months: [
                'January',
                'February',
                'March',
                'April',
                'May',
                'June',
                'July',
                'August',
                'September',
                'October',
                'November',
                'December'
            ],
            shortMonths: ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'],
            days: ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'],
            shortDays: ['S', 'M', 'T', 'W', 'T', 'F', 'S'],
            goToToday: 'Go to today',
            prevMonthAriaLabel: 'Go to previous month',
            nextMonthAriaLabel: 'Go to next month',
            prevYearAriaLabel: 'Go to previous year',
            nextYearAriaLabel: 'Go to next year',
            isRequiredErrorMessage: 'This date is required.',
            invalidInputErrorMessage: 'Invalid date format.'
        };
    };
    return DateFormField;
}(React.Component));
exports.default = DateFormField;
