"use strict";
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var Label_1 = require("office-ui-fabric-react/lib/Label");
var Utilities_1 = require("office-ui-fabric-react/lib/Utilities");
require("../FormField.module.scss");
var ardStyles = {
    formField: 'formField_d444b146',
    label: 'label_d444b146',
    controlContainerDisplay: 'controlContainerDisplay_d444b146'
};
var FormField = function (props) {
    var _a;
    var children = props.children, className = props.className, description = props.description, disabled = props.disabled, label = props.label, required = props.required, active = props.active, errorMessage = props.errorMessage;
    var formFieldClassName = Utilities_1.css('ard-formField', ardStyles.formField, className, (_a = {},
        _a['is-required '] = required,
        _a['is-disabled '] = disabled,
        _a['is-active '] = active,
        _a));
    var isDescriptionAvailable = Boolean(props.description || props.errorMessage);
    return (React.createElement("div", { className: Utilities_1.css(formFieldClassName, 'od-ClientFormFields-field') },
        React.createElement("div", { className: 'ard-FormField-wrapper' },
            label && (React.createElement(Label_1.Label, { className: ardStyles.label, htmlFor: _this._id, required: props.required }, label)),
            React.createElement("div", { className: Utilities_1.css('ard-FormField-fieldGroup', ardStyles.controlContainerDisplay) }, children)),
        isDescriptionAvailable && (React.createElement("span", null, description && React.createElement("span", { className: 'ard-FormField-description' }, description)))));
};
exports.default = FormField;
