"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var TextField_1 = require("office-ui-fabric-react/lib/TextField");
var NumberFormField = /** @class */ (function (_super) {
    __extends(NumberFormField, _super);
    function NumberFormField(props) {
        var _this = _super.call(this, props) || this;
        _this._validateNumber = _this._validateNumber.bind(_this);
        return _this;
    }
    NumberFormField.prototype.render = function () {
        // We need to set value to empty string when null or undefined to force
        // TextField not to be used like an uncontrolled component and keep current
        // value
        var value = this.props.value ? this.props.value : '';
        return (React.createElement(TextField_1.TextField, __assign({}, this.props, { className: "NumberFormField", label: this.props.label, value: value, onChanged: this.props.valueChanged, onGetErrorMessage: this._validateNumber })));
    };
    NumberFormField.prototype._validateNumber = function (value) {
        return isNaN(this.parseNumber(value, this.props.locale)) ? 'The value should be a number, actual is' : '';
    };
    NumberFormField.prototype.parseNumber = function (value, locale) {
        var decimalSperator = Intl.NumberFormat(locale).format(1.1).charAt(1);
        // const cleanPattern = new RegExp(`[^-+0-9${ example.charAt( 1 ) }]`, 'g');
        var cleanPattern = new RegExp("[" + '\' ,.'.replace(decimalSperator, '') + "]", 'g');
        var cleaned = value.replace(cleanPattern, '');
        var normalized = cleaned.replace(decimalSperator, '.');
        return Number(normalized);
    };
    return NumberFormField;
}(React.Component));
exports.default = NumberFormField;
