"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var Dropdown_1 = require("office-ui-fabric-react/lib/Dropdown");
var Utilities_1 = require("office-ui-fabric-react/lib/Utilities");
require("../SPFormField.scss");
var styles = {
    dropDownFormField: 'dropDownFormField_e5e89a2f',
    dateFormField: 'dateFormField_e5e89a2f',
    unsupportedFieldMessage: 'unsupportedFieldMessage_e5e89a2f'
};
var SPFieldChoiceEdit = function (props) {
    if (props.fieldSchema.FieldType !== 'MultiChoice') {
        var options = props.fieldSchema.Required
            ? props.fieldSchema.Choices
            : [''].concat(props.fieldSchema.Choices);
        return (React.createElement(Dropdown_1.Dropdown, { className: Utilities_1.css(styles.dropDownFormField, 'ard-choiceFormField'), options: options.map(function (option) { return ({ key: option, text: option }); }), selectedKey: props.value, onChanged: function (item) { return props.valueChanged(item.key.toString()); } }));
    }
    else {
        var options = props.fieldSchema.MultiChoices;
        var values_1 = props.value ? props.value.split(';#').filter(function (s) { return s; }) : [];
        return (React.createElement(Dropdown_1.Dropdown, { title: JSON.stringify(props.fieldSchema) + props.value, className: Utilities_1.css(styles.dropDownFormField, 'ard-multiChoiceFormField'), options: options.map(function (option) { return ({ key: option, text: option }); }), selectedKeys: values_1, multiSelect: true, onChanged: function (item) { return props.valueChanged(getUpdatedValue(values_1, item)); } }));
    }
};
function getUpdatedValue(oldValues, changedItem) {
    var changedKey = changedItem.key.toString();
    var newValues = oldValues.slice();
    if (changedItem.selected) {
        // add option if it's checked
        if (newValues.indexOf(changedKey) < 0) {
            newValues.push(changedKey);
        }
    }
    else {
        // remove the option if it's unchecked
        var currIndex = newValues.indexOf(changedKey);
        if (currIndex > -1) {
            newValues.splice(currIndex, 1);
        }
    }
    return newValues.join(';#');
}
exports.default = SPFieldChoiceEdit;
