"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var moment = require("moment");
var Utilities_1 = require("office-ui-fabric-react/lib/Utilities");
var Locales_1 = require("../../common/Locales");
var DateFormField_1 = require("./DateFormField");
require("../SPFormField.scss");
var styles = {
    dropDownFormField: 'dropDownFormField_e5e89a2f',
    dateFormField: 'dateFormField_e5e89a2f',
    unsupportedFieldMessage: 'unsupportedFieldMessage_e5e89a2f'
};
var SPFieldDateEdit = function (props) {
    var locale = Locales_1.Locales[props.fieldSchema.LocaleId];
    return (React.createElement(DateFormField_1.default, __assign({}, (props.value && moment(props.value).isValid() ? { value: moment(props.value).toDate() } : {}), { className: Utilities_1.css(styles.dateFormField, 'ard-dateFormField'), placeholder: 'Enter a date', isRequired: props.fieldSchema.Required, ariaLabel: props.fieldSchema.Title, locale: Locales_1.Locales[locale], firstDayOfWeek: props.fieldSchema.FirstDayOfWeek, allowTextInput: true, onSelectDate: function (date) { return props.valueChanged(date.toLocaleDateString(locale)); } })));
};
exports.default = SPFieldDateEdit;
