"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var Dropdown_1 = require("office-ui-fabric-react/lib/Dropdown");
var Utilities_1 = require("office-ui-fabric-react/lib/Utilities");
require("../SPFormField.scss");
var styles = {
    dropDownFormField: 'dropDownFormField_e5e89a2f',
    dateFormField: 'dateFormField_e5e89a2f',
    unsupportedFieldMessage: 'unsupportedFieldMessage_e5e89a2f'
};
var SPFieldLookupEdit = function (props) {
    var options = props.fieldSchema.Choices.map(function (option) { return ({ key: option.LookupId, text: option.LookupValue }); });
    if (props.fieldSchema.FieldType !== 'LookupMulti') {
        if (!props.required) {
            options = [
                {
                    key: 0,
                    text: '(None)'
                }
            ].concat(options);
        }
        var value = props.value ? Number(props.value.split(';#')[0]) : 0;
        return (React.createElement(Dropdown_1.Dropdown, { className: Utilities_1.css(styles.dropDownFormField, 'ard-lookupFormField'), options: options, selectedKey: value, onChanged: function (item) { return props.valueChanged(item.key + ";#" + item.text); } }));
    }
    else {
        var values_1 = [];
        if (props.value) {
            var splitArray_1 = props.value.split(';#');
            values_1 = splitArray_1.filter(function (item, idx) { return idx % 2 === 0; }).map(function (comp, idx) { return ({
                key: Number(comp),
                text: splitArray_1.length > idx + 1 ? splitArray_1[idx + 1] : ''
            }); });
        }
        return (React.createElement(Dropdown_1.Dropdown, { className: Utilities_1.css(styles.dropDownFormField, 'ard-lookupMultiFormField'), options: options, selectedKeys: values_1.map(function (val) { return val.key; }), multiSelect: true, onChanged: function (item) { return props.valueChanged(getUpdatedValue(values_1, item)); } }));
    }
};
function getUpdatedValue(oldValues, changedItem) {
    var newValues;
    if (changedItem.selected) {
        newValues = oldValues.concat([
            {
                key: Number(changedItem.key),
                text: changedItem.text
            }
        ]);
    }
    else {
        newValues = oldValues.filter(function (item) { return item.key !== changedItem.key; });
    }
    return newValues.reduce(function (valStr, item) { return valStr + (item.key + ";#" + item.text); }, '');
}
exports.default = SPFieldLookupEdit;
