"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
require("../SPFormField.scss");
var TaxonomyPicker_1 = require("../taxonomyPicker/TaxonomyPicker");
var typescript_string_operations_1 = require("typescript-string-operations");
var SPFieldTaxonomyEdit = function (props) {
    function extractGuid(value) {
        var regex = /([a-f0-9]{8}(?:-[a-f0-9]{4}){3}-[a-f0-9]{12})/i;
        // the RegEx will match the first occurrence of the pattern
        var match = regex.exec(value);
        // result is an array containing: [0] the entire string that was matched by our
        // RegEx [1] the first (only) group within our match, specified by the () within
        // our pattern, which contains the GUID value
        return match ? match[1] : null;
    }
    return (React.createElement(TaxonomyPicker_1.TaxonomyPicker, { termsetNameOrID: props.fieldSchema.TermSetId, panelTitle: "Select Term", label: "Select a Term", onChange: function (terms) {
            var builder = new typescript_string_operations_1.StringBuilder();
            for (var _i = 0, terms_1 = terms; _i < terms_1.length; _i++) {
                var term = terms_1[_i];
                builder.Append(term.Name + '|' + extractGuid(term.Id) + ';');
            }
            props.valueChanged(builder.ToString());
        }, allowMultipleSelections: props.fieldSchema.AllowMultipleValues, webUrl: props.webUrl }));
};
exports.default = SPFieldTaxonomyEdit;
