"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var TextField_1 = require("office-ui-fabric-react/lib/TextField");
var typescript_string_operations_1 = require("typescript-string-operations");
var SPFieldTextEdit = function (props) {
    // We need to set value to empty string when null or undefined to force
    // TextField still be used like a controlled component
    var value = props.value ? props.value : '';
    var illegalFileNames = ['/', '\\', '<', '>', ':', '*', '"', '?', '|', '.'];
    return (React.createElement(TextField_1.TextField, { className: "ard-TextFormField", name: props.fieldSchema.InternalName, value: value, onChanged: function (e) {
            props.valueChanged(e);
        }, placeholder: 'Enter value here', multiline: props.fieldSchema.FieldType === 'Note', errorMessage: props.fieldSchema.Required && typescript_string_operations_1.String.IsNullOrWhiteSpace(value) ? ('You can\'t leave this blank.') : props.fieldSchema.InternalName === 'FileLeafRef' &&
            illegalFileNames.some(function (substring) { return value.indexOf(substring) !== -1; }) ? ('File names can\'t begin or end with a period, or contain any of these characters: / \\  < > : * " ? |.') : null }));
};
exports.default = SPFieldTextEdit;
