import * as React from 'react';
import { ITaxonomyPickerProps, ITaxonomyPickerState } from './ITaxonomyPicker';
import '../TaxonomyPicker.module.scss';
/**
 * Image URLs / Base64
 */
export declare const COLLAPSED_IMG: string;
export declare const EXPANDED_IMG: string;
export declare const GROUP_IMG: string;
export declare const TERMSET_IMG: string;
export declare const TERM_IMG: string;
/**
 * Renders the controls for PropertyFieldTermPicker component
 */
export declare class TaxonomyPicker extends React.Component<ITaxonomyPickerProps, ITaxonomyPickerState> {
    private termsService;
    private previousValues;
    private cancel;
    /**
     * Constructor method
     */
    constructor(props: ITaxonomyPickerProps);
    /**
     * componentWillMount lifecycle hook
     */
    componentWillMount(): void;
    /**
     * componentWillUpdate lifecycle hook
     */
    componentDidUpdate(prevProps: ITaxonomyPickerProps): void;
    /**
     * Renders the SPListpicker controls with Office UI  Fabric
     */
    render(): JSX.Element;
    /**
     * Loads the list from SharePoint current web site
     */
    private loadTermStores;
    /**
     * Open the right Panel
     */
    private onOpenPanel;
    /**
     * Close the panel
     */
    private onClosePanel;
    /**
     * On save click action
     */
    private onSave;
    /**
     * Clicks on a node
     * @param node
     */
    private termsChanged;
    /**
     * Fires When Items Changed in TermPicker
     * @param node
     */
    private termsFromPickerChanged;
    /**
     * Gets the given node position in the active nodes collection
     * @param node
     */
    private getSelectedNodePosition;
}
