"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var Checkbox_1 = require("office-ui-fabric-react/lib/Checkbox");
require("../TaxonomyPicker.module.scss");
/**
 * Term component
 * Renders a selectable term
 */
var Term = /** @class */ (function (_super) {
    __extends(Term, _super);
    function Term(props) {
        var _this = _super.call(this, props) || this;
        // Check if current term is selected
        var active = _this.props.activeNodes.filter(function (item) { return item.Id === _this.props.term.Id; });
        _this.state = {
            selected: active.length > 0
        };
        _this._handleChange = _this._handleChange.bind(_this);
        return _this;
    }
    /**
     * Default React render
     */
    Term.prototype.render = function () {
        var styleProps = {
            marginLeft: this.props.term.PathDepth * 30 + "px"
        };
        return (React.createElement("div", { className: 'listItem' + " " + 'term', style: styleProps },
            React.createElement(Checkbox_1.Checkbox, { checked: this.state.selected, disabled: this.props.term.IsDeprecated || !this.props.term.IsAvailableForTagging || this.props.disabled, className: this.getClassName(), label: this.props.term.Name, onChange: this._handleChange })));
    };
    /**
     * Lifecycle event hook when component retrieves new properties
     * @param nextProps
     * @param nextContext
     */
    Term.prototype.componentWillReceiveProps = function (nextProps) {
        var _this = this;
        // If multi-selection is turned off, only a single term can be selected
        if (!this.props.multiSelection) {
            var active = nextProps.activeNodes.filter(function (item) { return item.Id === _this.props.term.Id; });
            this.state = {
                selected: active.length > 0
            };
        }
    };
    /**
     * Handle the checkbox change trigger
     */
    Term.prototype._handleChange = function (ev, isChecked) {
        this.setState({ selected: isChecked });
        this.props.changedCallback(this.props.term, isChecked);
    };
    /**
     * Get the right class name for the term
     */
    Term.prototype.getClassName = function () {
        if (this.props.term.IsDeprecated) {
            return 'termDisabled';
        }
        if (!this.props.term.IsAvailableForTagging) {
            return 'termNoTagging';
        }
        return 'termEnabled';
    };
    return Term;
}(React.Component));
exports.default = Term;
