import * as React from 'react';
import { BasePicker, IBasePickerProps, IPickerItemProps } from 'office-ui-fabric-react/lib/Pickers';
import { IPickerTerm, IPickerTerms } from './ITermPicker';
import '../TaxonomyPicker.module.scss';
import { ITaxonomyPickerProps } from './ITaxonomyPicker';
export declare class TermBasePicker extends BasePicker<IPickerTerm, IBasePickerProps<IPickerTerm>> {
}
export interface ITermPickerState {
    terms: IPickerTerms;
}
export interface ITermPickerProps {
    termPickerHostProps: ITaxonomyPickerProps;
    disabled: boolean;
    value: IPickerTerms;
    allowMultipleSelections: boolean;
    disabledTermIds?: string[];
    disableChildrenOfDisabledParents?: boolean;
    onChanged: (items: IPickerTerm[]) => void;
}
export default class TermPicker extends React.Component<ITermPickerProps, ITermPickerState> {
    private allTerms;
    /**
     * Constructor method
     */
    constructor(props: any);
    /**
     * componentWillReceiveProps method
     */
    componentWillReceiveProps(nextProps: ITermPickerProps): void;
    /**
     * Render method
     */
    render(): JSX.Element;
    /**
     * Renders the item in the picker
     */
    protected onRenderItem(term: IPickerItemProps<IPickerTerm>): JSX.Element;
    /**
     * Renders the suggestions in the picker
     */
    protected onRenderSuggestionsItem(term: IPickerTerm): JSX.Element;
    /**
     * When Filter Changes a new search for suggestions
     */
    private onFilterChanged;
    /**
     * gets the text from an item
     */
    private onGetTextFromItem;
}
