"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var Pickers_1 = require("office-ui-fabric-react/lib/Pickers");
var SPTermStorePickerService_1 = require("../../common/services/SPTermStorePickerService");
require("../TaxonomyPicker.module.scss");
var Icon_1 = require("office-ui-fabric-react/lib/Icon");
var TermBasePicker = /** @class */ (function (_super) {
    __extends(TermBasePicker, _super);
    function TermBasePicker() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return TermBasePicker;
}(Pickers_1.BasePicker));
exports.TermBasePicker = TermBasePicker;
var TermPicker = /** @class */ (function (_super) {
    __extends(TermPicker, _super);
    /**
     * Constructor method
     */
    function TermPicker(props) {
        var _this = _super.call(this, props) || this;
        _this.allTerms = null;
        _this.onRenderItem = _this.onRenderItem.bind(_this);
        _this.onRenderSuggestionsItem = _this.onRenderSuggestionsItem.bind(_this);
        _this.onFilterChanged = _this.onFilterChanged.bind(_this);
        _this.onGetTextFromItem = _this.onGetTextFromItem.bind(_this);
        _this.state = {
            terms: _this.props.value
        };
        return _this;
    }
    /**
     * componentWillReceiveProps method
     */
    TermPicker.prototype.componentWillReceiveProps = function (nextProps) {
        // check to see if props is different to avoid re-rendering
        var newKeys = nextProps.value.map(function (a) { return a.Id; });
        var currentKeys = this.state.terms.map(function (a) { return a.Id; });
        if (newKeys.sort().join(',') !== currentKeys.sort().join(',')) {
            this.setState({ terms: nextProps.value });
        }
    };
    /**
     * Render method
     */
    TermPicker.prototype.render = function () {
        return (React.createElement("div", null,
            React.createElement(TermBasePicker, { disabled: this.props.disabled, onResolveSuggestions: this.onFilterChanged, onRenderSuggestionsItem: this.onRenderSuggestionsItem, getTextFromItem: this.onGetTextFromItem, onRenderItem: this.onRenderItem, defaultSelectedItems: this.props.value, selectedItems: this.state.terms, onChange: this.props.onChanged, itemLimit: !this.props.allowMultipleSelections ? 1 : undefined, className: 'termBasePicker' })));
    };
    /**
     * Renders the item in the picker
     */
    TermPicker.prototype.onRenderItem = function (term) {
        return (React.createElement("div", { className: 'pickedTermRoot', key: term.index, "data-selection-index": term.index, "data-is-focusable": !term.disabled && true },
            React.createElement("span", { className: 'pickedTermText' }, term.item.Name),
            !term.disabled && (React.createElement("span", { className: 'pickedTermCloseIcon', onClick: term.onRemoveItem },
                React.createElement(Icon_1.Icon, { iconName: "Cancel" })))));
    };
    /**
     * Renders the suggestions in the picker
     */
    TermPicker.prototype.onRenderSuggestionsItem = function (term) {
        var termParent;
        var termTitle;
        term.sourceTerm.get().then(function (res) {
            termParent = res.Name;
            termTitle = term.Name + " [" + res.Name + "]";
            if (term.PathOfTerm.indexOf(';') !== -1) {
                var splitPath = term.PathOfTerm.split(';');
                termParent = splitPath[splitPath.length - 2];
                splitPath.pop();
                termTitle = term.Name + " [" + res.Name + ":" + splitPath.join(':') + "]";
            }
        });
        return (React.createElement("div", { className: 'termSuggestion', title: termTitle },
            React.createElement("div", null, term.Name),
            React.createElement("div", { className: 'termSuggestionSubTitle' },
                ' ',
                'in',
                termParent ? termParent : 'Term Set')));
    };
    /**
     * When Filter Changes a new search for suggestions
     */
    TermPicker.prototype.onFilterChanged = function (filterText, tagList) {
        return __awaiter(this, void 0, void 0, function () {
            var termsService, terms, filteredTerms, _a, disabledTermIds_1, disableChildrenOfDisabledParents, _loop_1, this_1, _i, terms_1, term;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!(filterText !== '')) return [3 /*break*/, 6];
                        termsService = new SPTermStorePickerService_1.default();
                        return [4 /*yield*/, termsService.searchTermsByTermSet(this.props.termPickerHostProps.webUrl, this.props.termPickerHostProps.termsetNameOrID, filterText)];
                    case 1:
                        terms = _b.sent();
                        filteredTerms = [];
                        _a = this.props, disabledTermIds_1 = _a.disabledTermIds, disableChildrenOfDisabledParents = _a.disableChildrenOfDisabledParents;
                        _loop_1 = function (term) {
                            var canBePicked, disabledParents, findTerm;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        canBePicked = true;
                                        if (!(disabledTermIds_1 && disabledTermIds_1.length > 0)) return [3 /*break*/, 4];
                                        if (!(disabledTermIds_1.indexOf(term.Id) !== -1)) return [3 /*break*/, 1];
                                        canBePicked = false;
                                        return [3 /*break*/, 4];
                                    case 1:
                                        if (!disableChildrenOfDisabledParents) return [3 /*break*/, 4];
                                        if (!!this_1.allTerms) return [3 /*break*/, 3];
                                        return [4 /*yield*/, termsService.getAllTerms(this_1.props.termPickerHostProps.webUrl, this_1.props.termPickerHostProps.termsetNameOrID)];
                                    case 2:
                                        this_1.allTerms = _a.sent();
                                        _a.label = 3;
                                    case 3:
                                        // Check if there are terms retrieved
                                        if (this_1.allTerms && this_1.allTerms.length > 0) {
                                            disabledParents = this_1.allTerms.filter(function (t) { return disabledTermIds_1.indexOf(t.Id) !== -1; });
                                            // Check if disabled parents were found
                                            if (disabledParents && disabledParents.length > 0) {
                                                findTerm = disabledParents.filter(function (pt) { return term.PathOfTerm.indexOf(pt.PathOfTerm) !== -1; });
                                                if (findTerm && findTerm.length > 0) {
                                                    canBePicked = false;
                                                }
                                            }
                                        }
                                        _a.label = 4;
                                    case 4:
                                        if (canBePicked) {
                                            // Only retrieve the terms which are not yet tagged
                                            if (tagList.filter(function (tag) { return tag.Id === term.Id; }).length === 0) {
                                                filteredTerms.push(term);
                                            }
                                        }
                                        return [2 /*return*/];
                                }
                            });
                        };
                        this_1 = this;
                        _i = 0, terms_1 = terms;
                        _b.label = 2;
                    case 2:
                        if (!(_i < terms_1.length)) return [3 /*break*/, 5];
                        term = terms_1[_i];
                        return [5 /*yield**/, _loop_1(term)];
                    case 3:
                        _b.sent();
                        _b.label = 4;
                    case 4:
                        _i++;
                        return [3 /*break*/, 2];
                    case 5: return [2 /*return*/, filteredTerms];
                    case 6: return [2 /*return*/, Promise.resolve([])];
                }
            });
        });
    };
    /**
     * gets the text from an item
     */
    TermPicker.prototype.onGetTextFromItem = function (item) {
        return item.name;
    };
    return TermPicker;
}(React.Component));
exports.default = TermPicker;
